# AmoebaBondForce Class Reference

This class implements an interaction between pairs of particles that varies with the distance between them. More...

`#include <AmoebaBondForce.h>`

Inheritance diagram for AmoebaBondForce:

List of all members.

## Classes
class | BondInfo
| This is an internal class used to record information about a bond.
## Public Member Functions
| AmoebaBondForce ()
| Create an AmoebaBondForce.
int | getNumBonds () const
| Get the number of bond stretch terms in the potential function.
void | setAmoebaGlobalBondCubic (double cubicK)
| Set the global cubic term.
double | getAmoebaGlobalBondCubic (void) const
| Get the global cubic term.
void | setAmoebaGlobalBondQuartic (double quarticK)
| Set the global quartic term.
double | getAmoebaGlobalBondQuartic (void) const
| Get the global quartic term.
int | addBond (int particle1, int particle2, double length, double quadraticK)
| Add a bond term to the force field.
void | getBondParameters (int index, int &particle1, int &particle2, double &length, double &quadraticK) const
| Get the force field parameters for a bond term.
void | setBondParameters (int index, int particle1, int particle2, double length, double quadraticK)
| Set the force field parameters for a bond term.
void | updateParametersInContext (Context &context)
| Update the per-bond parameters in a Context to match those stored in this Force object.
## Protected Member Functions
ForceImpl * | createImpl () const
| When a Context is created, it invokes this method on each Force in the System.
## Protected Attributes
double | _globalQuarticK
double | _globalCubicK

## Detailed Description

This class implements an interaction between pairs of particles that varies with the distance between them.

The interaction is defined by a 4th order polynomial. Only the quadratic term is set per-bond. The coefficients of the higher order terms each have a single value that is set globally.

To use it, create an AmoebaBondForce object then call addBond() once for each bond. After a bond has been added, you can modify its force field parameters by calling setBondParameters(). This will have no effect on Contexts that already exist unless you call updateParametersInContext().

## Constructor & Destructor Documentation

AmoebaBondForce | ( |  | ) |

Create an AmoebaBondForce.

## Member Function Documentation

int addBond | ( | int | particle1,
|  | int | particle2,
|  | double | length,
|  | double | quadraticK |
| ) |  |  |

Add a bond term to the force field.

Parameters:

  | particle1 | the index of the first particle connected by the bond
  | particle2 | the index of the second particle connected by the bond
  | length | the equilibrium length of the bond, measured in nm
  | k | the quadratic force constant for the bond

Returns:
  the index of the bond that was added

ForceImpl* createImpl | ( |  | ) | const`[protected, virtual]`

When a Context is created, it invokes this method on each Force in the System.

It should create a new ForceImpl object which can be used by the context for calculating forces. The ForceImpl will be deleted automatically when the Context is deleted.

Implements Force.

double getAmoebaGlobalBondCubic | ( | void |  | ) | const

Get the global cubic term.

Returns:
  global cubicK term

double getAmoebaGlobalBondQuartic | ( | void |  | ) | const

Get the global quartic term.

Returns:
  global quartic term

void getBondParameters | ( | int | index,
|  | int & | particle1,
|  | int & | particle2,
|  | double & | length,
|  | double & | quadraticK |
| ) |  |  | const

Get the force field parameters for a bond term.

Parameters:

  | index | the index of the bond for which to get parameters
  | particle1 | the index of the first particle connected by the bond
  | particle2 | the index of the second particle connected by the bond
  | length | the equilibrium length of the bond, measured in nm
  | quadratic | k the quadratic force constant for the bond

int getNumBonds | ( |  | ) | const`[inline]`

Get the number of bond stretch terms in the potential function.

void setAmoebaGlobalBondCubic | ( | double | cubicK | ) |

Set the global cubic term.

Parameters:

  | cubicK | the cubic force constant for the bond

void setAmoebaGlobalBondQuartic | ( | double | quarticK | ) |

Set the global quartic term.

Parameters:

  | quarticK | the quartic force constant for the bond

void setBondParameters | ( | int | index,
|  | int | particle1,
|  | int | particle2,
|  | double | length,
|  | double | quadraticK |
| ) |  |  |

Set the force field parameters for a bond term.

Parameters:

  | index | the index of the bond for which to set parameters
  | particle1 | the index of the first particle connected by the bond
  | particle2 | the index of the second particle connected by the bond
  | length | the equilibrium length of the bond, measured in nm
  | k | the quadratic force constant for the bond

void updateParametersInContext | ( | Context & | context | ) |

Update the per-bond parameters in a Context to match those stored in this Force object.

This method provides an efficient method to update certain parameters in an existing Context without needing to reinitialize it. Simply call setBondParameters() to modify this object's parameters, then call updateParametersInState() to copy them over to the Context.

The only information this method updates is the values of per-bond parameters. The set of particles involved in a bond cannot be changed, nor can new bonds be added.

## Member Data Documentation

double _globalCubicK`[protected]`

double _globalQuarticK`[protected]`

The documentation for this class was generated from the following file:

- AmoebaBondForce.h